/*
	File:		VideoPart.cpp
	Contains:	Implementation of the SOM class VideoPart
	Written by:	PartMaker

	Change History (most recent first):

	<3>	4/18/95	JS		Updated to Developer Release 2
						Add ClonePartInfo.
						Inherited for InitPart, InitPartFromStorage.
						Fixed Externalize() inherited call.
						Removed inherited from Release().
						delete to ODDeleteObject().
	<2>	3/8/95	JS		Updated to b1c13/c14
	<1>	2/2/95	RA		first checked in
	<0>	PartMaker source by E. Soldan, T. elik, J. Alfke, R. Adkins, D. Nelson, J. Schalk
*/

#ifndef _ALTPOINT_
#include <AltPoint.h>
#endif

#ifndef SOM_ODFrame_xh
#include <Frame.xh>
#endif

#ifndef SOM_ODFacet_xh
#include <Facet.xh>
#endif

#ifndef SOM_ODShape_xh
#include <Shape.xh>
#endif

#ifndef SOM_ODDraft_xh
#include <Draft.xh>
#endif

#ifndef SOM_ODStorageUnit_xh
#include <StorageU.xh>
#endif

#ifndef SOM_ODTransform_xh
#include <Trnsform.xh>
#endif

#ifndef SOM_ODWindow_xh
#include <Window.xh>
#endif

#ifndef __QUICKDRAW__
#include <Quickdraw.h>
#endif

#ifndef _CPVIDEOPART_
#include "CPVideoPart.h"
#endif

#define SOM_Module_videopart_Source
#define VARIABLE_MACROS

#ifndef SOM_Jovian_VideoPart_xih
#include <VideoPart.xih>
#endif

#ifndef _ODUTILS_
#include <ODUtils.h>
#endif

//========================================================================================
// Jovian_VideoPart
//========================================================================================

SOM_Scope void  SOMLINK Jovian_VideoPartsomInit(Jovian_VideoPart *somSelf)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	_fCPPart = kODNULL;
    Jovian_VideoPart_parent_ODPart_somInit(somSelf);
}

SOM_Scope void  SOMLINK Jovian_VideoPartsomUninit(Jovian_VideoPart *somSelf)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	if (_fCPPart)
		ODDeleteObject(_fCPPart);
    Jovian_VideoPart_parent_ODPart_somUninit(somSelf);
}

SOM_Scope void  SOMLINK Jovian_VideoPartFulfillPromise(Jovian_VideoPart *somSelf,
		Environment *ev,
		ODStorageUnitView* promiseSUView)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->FulfillPromise(ev,promiseSUView);
}

SOM_Scope void  SOMLINK Jovian_VideoPartDropCompleted(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODPart* destPart,
		ODDropResult dropResult)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->DropCompleted(ev,destPart,dropResult);
}

SOM_Scope ODDragResult  SOMLINK Jovian_VideoPartDragEnter(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODDragItemIterator* dragInfo,
		ODFacet* facet,
		ODPoint* where)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    return (_fCPPart->DragEnter(ev,dragInfo,facet,where));
}

SOM_Scope ODDragResult  SOMLINK Jovian_VideoPartDragWithin(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODDragItemIterator* dragInfo,
		ODFacet* facet,
		ODPoint* where)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    return (_fCPPart->DragWithin(ev,dragInfo,facet,where));
}

SOM_Scope void  SOMLINK Jovian_VideoPartDragLeave(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFacet* facet,
		ODPoint* where)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->DragLeave(ev,facet,where);
}

SOM_Scope ODDropResult  SOMLINK Jovian_VideoPartDrop(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODDragItemIterator* dropInfo,
		ODFacet* facet,
		ODPoint* where)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    return (_fCPPart->Drop(ev,dropInfo,facet,where));
}

SOM_Scope void  SOMLINK Jovian_VideoPartContainingPartPropertiesChanged(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODStorageUnit* propertyUnit)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->ContainingPartPropertiesChanged(ev,frame,propertyUnit);
}

SOM_Scope ODStorageUnit*  SOMLINK Jovian_VideoPartGetContainingPartProperties(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    return (_fCPPart->GetContainingPartProperties(ev,frame));
}

SOM_Scope ODBoolean  SOMLINK Jovian_VideoPartRevealFrame(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame,
		ODShape* revealShape)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    return (_fCPPart->RevealFrame(ev,embeddedFrame,revealShape));
}

SOM_Scope void  SOMLINK Jovian_VideoPartEmbeddedFrameSpec(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame,
		ODObjectSpec* spec)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->EmbeddedFrameSpec(ev,embeddedFrame,spec);
}

SOM_Scope ODEmbeddedFramesIterator*  SOMLINK Jovian_VideoPartCreateEmbeddedFramesIterator(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    return (_fCPPart->CreateEmbeddedFramesIterator(ev,frame));
}

SOM_Scope void  SOMLINK Jovian_VideoPartDisplayFrameAdded(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
	Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->DisplayFrameAdded(ev,frame);
}

SOM_Scope void  SOMLINK Jovian_VideoPartDisplayFrameRemoved(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->DisplayFrameRemoved(ev,frame);
}

SOM_Scope void  SOMLINK Jovian_VideoPartDisplayFrameConnected(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->DisplayFrameConnected(ev,frame);
}

SOM_Scope void  SOMLINK Jovian_VideoPartDisplayFrameClosed(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->DisplayFrameClosed(ev,frame);
}

SOM_Scope void  SOMLINK Jovian_VideoPartAttachSourceFrame(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODFrame* sourceFrame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->AttachSourceFrame(ev,frame,sourceFrame);
}

SOM_Scope void  SOMLINK Jovian_VideoPartFrameShapeChanged(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->FrameShapeChanged(ev,frame);
}

SOM_Scope void  SOMLINK Jovian_VideoPartViewTypeChanged(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->ViewTypeChanged(ev,frame);
}

SOM_Scope void  SOMLINK Jovian_VideoPartPresentationChanged(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->PresentationChanged(ev,frame);
}

SOM_Scope void  SOMLINK Jovian_VideoPartSequenceChanged(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->SequenceChanged(ev,frame);
}

SOM_Scope void  SOMLINK Jovian_VideoPartWritePartInfo(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODInfoType partInfo,
		ODStorageUnitView* storageUnitView)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->WritePartInfo(ev,partInfo,storageUnitView);
}

SOM_Scope ODInfoType  SOMLINK Jovian_VideoPartReadPartInfo(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODStorageUnitView* storageUnitView)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    return (_fCPPart->ReadPartInfo(ev,frame,storageUnitView));
}

SOM_Scope void  SOMLINK Jovian_VideoPartClonePartInfo(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODDraftKey key,
		ODInfoType partInfo,
		ODStorageUnitView* storageUnitView,
		ODFrame* scopeFrame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->ClonePartInfo(ev,key,partInfo,storageUnitView,scopeFrame);
}

SOM_Scope ODID  SOMLINK Jovian_VideoPartOpen(Jovian_VideoPart *somSelf,
		Environment *ev,
		ODFrame* frame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	return (_fCPPart->Open(ev,frame));
}

SOM_Scope ODFrame*  SOMLINK Jovian_VideoPartRequestEmbeddedFrame(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* containingFrame,
		ODFrame* baseFrame,
		ODShape* frameShape,
		ODPart* embedPart,
		ODTypeToken viewType,
		ODTypeToken presentation,
		ODBoolean isOverlaid)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	return (_fCPPart->RequestEmbeddedFrame(ev,containingFrame,baseFrame,frameShape,embedPart,viewType,presentation,isOverlaid));
}

SOM_Scope void  SOMLINK Jovian_VideoPartRemoveEmbeddedFrame(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->RemoveEmbeddedFrame(ev,embeddedFrame);
}

SOM_Scope ODShape*  SOMLINK Jovian_VideoPartRequestFrameShape(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame,
		ODShape* frameShape)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	return (_fCPPart->RequestFrameShape(ev,embeddedFrame,frameShape));
}

SOM_Scope void  SOMLINK Jovian_VideoPartUsedShapeChanged(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* embeddedFrame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->UsedShapeChanged(ev,embeddedFrame);
}

SOM_Scope ODShape*  SOMLINK Jovian_VideoPartAdjustBorderShape(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFacet* embeddedFacet,
		ODShape* shape)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    return (_fCPPart->AdjustBorderShape(ev,embeddedFacet,shape));
}

SOM_Scope void  SOMLINK Jovian_VideoPartFacetAdded(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->FacetAdded(ev,facet);
}

SOM_Scope void  SOMLINK Jovian_VideoPartFacetRemoved(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	_fCPPart->FacetRemoved(ev,facet);
}

SOM_Scope void  SOMLINK Jovian_VideoPartCanvasChanged(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	_fCPPart->CanvasChanged(ev,facet);
}

SOM_Scope void  SOMLINK Jovian_VideoPartGeometryChanged(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFacet* facet,
		ODBoolean clipShapeChanged,
		ODBoolean externalTransformChanged)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	_fCPPart->GeometryChanged(ev,facet,clipShapeChanged,externalTransformChanged);
}

SOM_Scope void  SOMLINK Jovian_VideoPartDraw(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFacet* facet,
		ODShape* invalidShape)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	_fCPPart->Draw(ev,facet,invalidShape);
}

SOM_Scope void  SOMLINK Jovian_VideoPartCanvasUpdated(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODCanvas* canvas)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	_fCPPart->CanvasUpdated(ev,canvas);
}

SOM_Scope void  SOMLINK Jovian_VideoPartHighlightChanged(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFacet* facet)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	_fCPPart->HighlightChanged(ev,facet);
}

SOM_Scope ODULong  SOMLINK Jovian_VideoPartGetPrintResolution(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	return (_fCPPart->GetPrintResolution(ev,frame));
}

SOM_Scope ODLinkSource*  SOMLINK Jovian_VideoPartCreateLink(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODByteArray* data)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	return (_fCPPart->CreateLink(ev,data));
}

SOM_Scope void  SOMLINK Jovian_VideoPartLinkUpdated(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODLink* updatedLink,
		ODChangeID id)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	_fCPPart->LinkUpdated(ev,updatedLink,id);
}

SOM_Scope void  SOMLINK Jovian_VideoPartRevealLink(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODLinkSource* linkSource)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	_fCPPart->RevealLink(ev,linkSource);
}

SOM_Scope void  SOMLINK Jovian_VideoPartEmbeddedFrameChanged(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* frame,
		ODChangeID change)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	_fCPPart->EmbeddedFrameChanged(ev,frame,change);
}

SOM_Scope void  SOMLINK Jovian_VideoPartLinkStatusChanged(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	_fCPPart->LinkStatusChanged(ev,frame);
}

SOM_Scope ODBoolean  SOMLINK Jovian_VideoPartBeginRelinquishFocus(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame,
		ODFrame* proposedFrame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	return (_fCPPart->BeginRelinquishFocus(ev,focus,ownerFrame,proposedFrame));
}

SOM_Scope void  SOMLINK Jovian_VideoPartCommitRelinquishFocus(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame,
		ODFrame* proposedFrame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	_fCPPart->CommitRelinquishFocus(ev,focus,ownerFrame,proposedFrame);
}

SOM_Scope void  SOMLINK Jovian_VideoPartAbortRelinquishFocus(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame,
		ODFrame* proposedFrame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	_fCPPart->AbortRelinquishFocus(ev,focus,ownerFrame,proposedFrame);
}

SOM_Scope void  SOMLINK Jovian_VideoPartFocusAcquired(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	_fCPPart->FocusAcquired(ev,focus,ownerFrame);
}

SOM_Scope void  SOMLINK Jovian_VideoPartFocusLost(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODTypeToken focus,
		ODFrame* ownerFrame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	_fCPPart->FocusLost(ev,focus,ownerFrame);
}

SOM_Scope ODBoolean  SOMLINK Jovian_VideoPartHasExtension(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODType extensionName)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	return (_fCPPart->HasExtension(ev,extensionName));
}

SOM_Scope ODExtension*  SOMLINK Jovian_VideoPartGetExtension(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODType extensionName)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	return (_fCPPart->GetExtension(ev,extensionName));
}

SOM_Scope void  SOMLINK Jovian_VideoPartReleaseExtension(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODExtension* extension)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	_fCPPart->ReleaseExtension(ev,extension);
}

SOM_Scope ODSize  SOMLINK Jovian_VideoPartPurge(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODSize size)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    if  (_fCPPart)
		return (_fCPPart->Purge(ev,size));
	else
		return (Jovian_VideoPart_parent_ODPart_Purge(somSelf,ev,size));
}

SOM_Scope void  SOMLINK Jovian_VideoPartIncrementRefCount(Jovian_VideoPart *somSelf, 
		Environment *ev)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    Jovian_VideoPart_parent_ODPart_IncrementRefCount(somSelf,ev);

	_fCPPart->IncrementRefCount(ev);
}

SOM_Scope void  SOMLINK Jovian_VideoPartRelease(Jovian_VideoPart *somSelf, 
		Environment *ev)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    Jovian_VideoPart_parent_ODPart_Release(somSelf,ev);

    if (_fCPPart)
    	_fCPPart->Release(ev);
    	
	if (somSelf->GetRefCount(ev) == 0)
		somSelf->GetStorageUnit(ev)->GetDraft(ev)->ReleasePart(ev, somSelf);
}

SOM_Scope void  SOMLINK Jovian_VideoPartReleaseAll(Jovian_VideoPart *somSelf, 
		Environment *ev)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->ReleaseAll(ev);
}

SOM_Scope void  SOMLINK Jovian_VideoPartExternalize(Jovian_VideoPart *somSelf, 
		Environment *ev)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	Jovian_VideoPart_parent_ODPart_Externalize(somSelf,ev);

	_fCPPart->Externalize(ev);
}

SOM_Scope void  SOMLINK Jovian_VideoPartCloneInto(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODDraftKey key,
		ODStorageUnit* storageUnit,
		ODFrame* initiatingFrame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	Jovian_VideoPart_parent_ODPart_CloneInto(somSelf,ev,key,storageUnit,initiatingFrame);

    _fCPPart->CloneInto(ev,key,storageUnit,initiatingFrame);
}

SOM_Scope void  SOMLINK Jovian_VideoPartExternalizeKinds(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODTypeList* kindset)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->ExternalizeKinds(ev,kindset);
}

SOM_Scope void  SOMLINK Jovian_VideoPartChangeKind(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODType kind)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->ChangeKind(ev,kind);
}

SOM_Scope ODBoolean  SOMLINK Jovian_VideoPartHandleEvent(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODEventData* event,
		ODFrame* frame,
		ODFacet* facet,
		ODEventInfo* eventInfo)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    return (_fCPPart->HandleEvent(ev,event,frame,facet,eventInfo));
}

SOM_Scope void  SOMLINK Jovian_VideoPartAdjustMenus(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODFrame* frame)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->AdjustMenus(ev,frame);
}

SOM_Scope void  SOMLINK Jovian_VideoPartUndoAction(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODActionData* actionState)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->UndoAction(ev,actionState);
}

SOM_Scope void  SOMLINK Jovian_VideoPartRedoAction(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODActionData* actionState)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->RedoAction(ev,actionState);
}

SOM_Scope void  SOMLINK Jovian_VideoPartDisposeActionState(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODActionData* actionState,
		ODDoneState doneState)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->DisposeActionState(ev,actionState,doneState);
}

SOM_Scope void  SOMLINK Jovian_VideoPartWriteActionState(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODActionData* actionState,
		ODStorageUnitView* storageUnitView)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    _fCPPart->WriteActionState(ev,actionState,storageUnitView);
}

SOM_Scope ODActionData  SOMLINK Jovian_VideoPartReadActionState(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODStorageUnitView* storageUnitView)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
    return (_fCPPart->ReadActionState(ev,storageUnitView));
}

SOM_Scope void  SOMLINK Jovian_VideoPartInitPart(Jovian_VideoPart *somSelf,
		Environment *ev,
		ODStorageUnit* storageUnit, ODPart* partWrapper)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	if (somSelf->IsInitialized(ev))
		return;
	
	Jovian_VideoPart_parent_ODPart_InitPart(somSelf,ev,storageUnit,partWrapper);
	
    _fCPPart = new CPVideoPart; // $$$$$ Check to see if it is nil
    _fCPPart->InitPart(ev,storageUnit, (ODPart*)partWrapper);
}

SOM_Scope void  SOMLINK Jovian_VideoPartInitPartFromStorage(Jovian_VideoPart *somSelf, 
		Environment *ev,
		ODStorageUnit* storageUnit, ODPart* partWrapper)
{
    Jovian_VideoPartData *somThis = Jovian_VideoPartGetData(somSelf);
	if (somSelf->IsInitialized(ev))
		return;

	Jovian_VideoPart_parent_ODPart_InitPartFromStorage(somSelf,ev,storageUnit,partWrapper);
	
    _fCPPart = new CPVideoPart; // $$$$$ Check to see if it is nil
	_fCPPart->InitPartFromStorage(ev,storageUnit, (ODPart*)partWrapper);
}

