/*
	File:		VideoPartInit.cpp
	Contains:	Init routines
	Written by:	PartMaker

	Change History (most recent first):

	<3>	3/20/95	JS		Updated for Developer Release 2.
	<3>	3/20/95	JS		Use InitODMemory()
	<2>	3/8/95	JS		Updated to b1c13/c14
	<1>	2/2/95	RA		first checked in
	<0>	PartMaker source by E. Soldan, T. elik, J. Alfke, R. Adkins, D. Nelson, J. Schalk
*/

#ifndef _ALTPOINT_
#include <AltPoint.h>
#endif

#ifndef __SOM__
#include <som.xh>
#endif

#ifndef __SOMOBJ__
#include <somobj.xh>
#endif

#ifndef __USERSRCM__
#include <UseRsrcM.h>
#endif

#ifndef __CODEFRAGMENTS__
#include <CodeFragments.h>
#endif

#ifndef SOM_Module_videopart_Source
#include "VideoPart.xh"
#endif

#ifndef _VIDEOPART_
#include "CPVideoPart.h"
#endif

//---------------------------------------------------------------------------------------
// Library initialization routine
//---------------------------------------------------------------------------------------

extern "C" pascal OSErr VideoPartCFMInit (CFragInitBlockPtr initBlkPtr);

pascal OSErr VideoPartCFMInit (CFragInitBlockPtr initBlkPtr)
{
	EnteringMethod("\pVideoPartCFMInit");

	OSErr err1 = InitODMemory();
	OSErr err2 = InitLibraryResources(initBlkPtr);
	
	return err1 ? err1 : err2;
}

//---------------------------------------------------------------------------------------
// Library main routine
//---------------------------------------------------------------------------------------

SOMEXTERN void SOMLINK VideoPartSOMInit (long majorVersion, 
                                       long minorVersion, 
                                       string className);
                                       
SOMEXTERN void SOMLINK VideoPartSOMInit (long majorVersion, 
                                       long minorVersion, 
                                       string className)
{
	EnteringMethod("\pVideoPartSOMInit");

	Jovian_VideoPartNewClass(majorVersion, minorVersion);
}

